// Copyright 2014 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// This file has been auto-generated from the Jinja2 template
// third_party/blink/renderer/bindings/templates/dictionary_v8.cc.tmpl
// by the script code_generator_v8.py.
// DO NOT MODIFY!

// clang-format off
#include "third_party/blink/renderer/bindings/core/v8/v8_window_post_message_options.h"

#include "base/stl_util.h"
#include "third_party/blink/renderer/bindings/core/v8/idl_types.h"
#include "third_party/blink/renderer/bindings/core/v8/native_value_traits_impl.h"
#include "third_party/blink/renderer/bindings/core/v8/v8_post_message_options.h"
#include "third_party/blink/renderer/core/execution_context/execution_context.h"
#include "third_party/blink/renderer/core/origin_trials/origin_trials.h"
#include "third_party/blink/renderer/platform/bindings/exception_state.h"
#include "third_party/blink/renderer/platform/runtime_enabled_features.h"

namespace blink {

static const v8::Eternal<v8::Name>* eternalV8WindowPostMessageOptionsKeys(v8::Isolate* isolate) {
  static const char* const kKeys[] = {
    "allow",
    "targetOrigin",
    "transferUserActivation",
  };
  return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(
      kKeys, kKeys, base::size(kKeys));
}

void V8WindowPostMessageOptions::ToImpl(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, WindowPostMessageOptions* impl, ExceptionState& exception_state) {
  if (IsUndefinedOrNull(v8_value)) {
    return;
  }
  if (!v8_value->IsObject()) {
    exception_state.ThrowTypeError("cannot convert to dictionary.");
    return;
  }
  v8::Local<v8::Object> v8Object = v8_value.As<v8::Object>();
  ALLOW_UNUSED_LOCAL(v8Object);

  V8PostMessageOptions::ToImpl(isolate, v8_value, impl, exception_state);
  if (exception_state.HadException())
    return;

  const v8::Eternal<v8::Name>* keys = eternalV8WindowPostMessageOptionsKeys(isolate);
  v8::TryCatch block(isolate);
  v8::Local<v8::Context> context = isolate->GetCurrentContext();
  ExecutionContext* executionContext = ToExecutionContext(context);
  DCHECK(executionContext);
  v8::Local<v8::Value> target_origin_value;
  if (!v8Object->Get(context, keys[1].Get(isolate)).ToLocal(&target_origin_value)) {
    exception_state.RethrowV8Exception(block.Exception());
    return;
  }
  if (target_origin_value.IsEmpty() || target_origin_value->IsUndefined()) {
    // Do nothing.
  } else {
    V8StringResource<> target_origin_cpp_value = NativeValueTraits<IDLUSVString>::NativeValue(isolate, target_origin_value, exception_state);
    if (exception_state.HadException())
      return;
    impl->setTargetOrigin(target_origin_cpp_value);
  }

  if (RuntimeEnabledFeatures::UserActivationPostMessageTransferEnabled()) {
    v8::Local<v8::Value> transfer_user_activation_value;
    if (!v8Object->Get(context, keys[2].Get(isolate)).ToLocal(&transfer_user_activation_value)) {
      exception_state.RethrowV8Exception(block.Exception());
      return;
    }
    if (transfer_user_activation_value.IsEmpty() || transfer_user_activation_value->IsUndefined()) {
      // Do nothing.
    } else {
      bool transfer_user_activation_cpp_value = NativeValueTraits<IDLBoolean>::NativeValue(isolate, transfer_user_activation_value, exception_state);
      if (exception_state.HadException())
        return;
      impl->setTransferUserActivation(transfer_user_activation_cpp_value);
    }
  }

  if (RuntimeEnabledFeatures::ExperimentalAutoplayDynamicDelegationEnabled(executionContext)) {
    v8::Local<v8::Value> allow_value;
    if (!v8Object->Get(context, keys[0].Get(isolate)).ToLocal(&allow_value)) {
      exception_state.RethrowV8Exception(block.Exception());
      return;
    }
    if (allow_value.IsEmpty() || allow_value->IsUndefined()) {
      // Do nothing.
    } else {
      V8StringResource<> allow_cpp_value = allow_value;
      if (!allow_cpp_value.Prepare(exception_state))
        return;
      impl->setAllow(allow_cpp_value);
    }
  }
}

v8::Local<v8::Value> WindowPostMessageOptions::ToV8Impl(v8::Local<v8::Object> creationContext, v8::Isolate* isolate) const {
  v8::Local<v8::Object> v8Object = v8::Object::New(isolate);
  if (!toV8WindowPostMessageOptions(this, v8Object, creationContext, isolate))
    return v8::Undefined(isolate);
  return v8Object;
}

bool toV8WindowPostMessageOptions(const WindowPostMessageOptions* impl, v8::Local<v8::Object> dictionary, v8::Local<v8::Object> creationContext, v8::Isolate* isolate) {
  if (!toV8PostMessageOptions(impl, dictionary, creationContext, isolate))
    return false;

  const v8::Eternal<v8::Name>* keys = eternalV8WindowPostMessageOptionsKeys(isolate);
  v8::Local<v8::Context> context = isolate->GetCurrentContext();

  auto create_property = [dictionary, context, keys, isolate](
                             size_t key_index, v8::Local<v8::Value> value) {
    bool added_property;
    v8::Local<v8::Name> key = keys[key_index].Get(isolate);
    if (!dictionary->CreateDataProperty(context, key, value)
             .To(&added_property)) {
      return false;
    }
    return added_property;
  };

  ExecutionContext* executionContext = ToExecutionContext(context);
  DCHECK(executionContext);
  v8::Local<v8::Value> target_origin_value;
  bool target_origin_has_value_or_default = false;
  if (impl->hasTargetOrigin()) {
    target_origin_value = V8String(isolate, impl->targetOrigin());
    target_origin_has_value_or_default = true;
  } else {
    target_origin_value = V8String(isolate, "/");
    target_origin_has_value_or_default = true;
  }
  if (target_origin_has_value_or_default &&
      !create_property(1, target_origin_value)) {
    return false;
  }

  if (RuntimeEnabledFeatures::UserActivationPostMessageTransferEnabled()) {
    v8::Local<v8::Value> transfer_user_activation_value;
    bool transfer_user_activation_has_value_or_default = false;
    if (impl->hasTransferUserActivation()) {
      transfer_user_activation_value = v8::Boolean::New(isolate, impl->transferUserActivation());
      transfer_user_activation_has_value_or_default = true;
    } else {
      transfer_user_activation_value = v8::Boolean::New(isolate, false);
      transfer_user_activation_has_value_or_default = true;
    }
    if (transfer_user_activation_has_value_or_default &&
        !create_property(2, transfer_user_activation_value)) {
      return false;
    }
  }

  if (RuntimeEnabledFeatures::ExperimentalAutoplayDynamicDelegationEnabled(executionContext)) {
    v8::Local<v8::Value> allow_value;
    bool allow_has_value_or_default = false;
    if (impl->hasAllow()) {
      allow_value = V8String(isolate, impl->allow());
      allow_has_value_or_default = true;
    } else {
      allow_value = V8String(isolate, WTF::g_empty_string);
      allow_has_value_or_default = true;
    }
    if (allow_has_value_or_default &&
        !create_property(0, allow_value)) {
      return false;
    }
  }

  return true;
}

WindowPostMessageOptions* NativeValueTraits<WindowPostMessageOptions>::NativeValue(v8::Isolate* isolate, v8::Local<v8::Value> value, ExceptionState& exception_state) {
  WindowPostMessageOptions* impl = WindowPostMessageOptions::Create();
  V8WindowPostMessageOptions::ToImpl(isolate, value, impl, exception_state);
  return impl;
}

}  // namespace blink
