// Copyright 2014 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// This file has been auto-generated from the Jinja2 template
// third_party/blink/renderer/bindings/templates/dictionary_v8.cc.tmpl
// by the script code_generator_v8.py.
// DO NOT MODIFY!

// clang-format off
#include "third_party/blink/renderer/bindings/modules/v8/v8_display.h"

#include "base/stl_util.h"
#include "third_party/blink/renderer/bindings/core/v8/idl_types.h"
#include "third_party/blink/renderer/bindings/core/v8/native_value_traits_impl.h"
#include "third_party/blink/renderer/platform/bindings/exception_state.h"

namespace blink {

static const v8::Eternal<v8::Name>* eternalV8DisplayKeys(v8::Isolate* isolate) {
  static const char* const kKeys[] = {
    "colorDepth",
    "height",
    "isInternal",
    "isPrimary",
    "left",
    "name",
    "scaleFactor",
    "top",
    "width",
  };
  return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(
      kKeys, kKeys, base::size(kKeys));
}

void V8Display::ToImpl(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, Display* impl, ExceptionState& exception_state) {
  if (IsUndefinedOrNull(v8_value)) {
    exception_state.ThrowTypeError("Missing required member(s): colorDepth, height, isInternal, isPrimary, left, name, scaleFactor, top, width.");
    return;
  }
  if (!v8_value->IsObject()) {
    exception_state.ThrowTypeError("cannot convert to dictionary.");
    return;
  }
  v8::Local<v8::Object> v8Object = v8_value.As<v8::Object>();
  ALLOW_UNUSED_LOCAL(v8Object);

  const v8::Eternal<v8::Name>* keys = eternalV8DisplayKeys(isolate);
  v8::TryCatch block(isolate);
  v8::Local<v8::Context> context = isolate->GetCurrentContext();
  v8::Local<v8::Value> color_depth_value;
  if (!v8Object->Get(context, keys[0].Get(isolate)).ToLocal(&color_depth_value)) {
    exception_state.RethrowV8Exception(block.Exception());
    return;
  }
  if (color_depth_value.IsEmpty() || color_depth_value->IsUndefined()) {
    exception_state.ThrowTypeError("required member colorDepth is undefined.");
    return;
  } else {
    int32_t color_depth_cpp_value = NativeValueTraits<IDLLong>::NativeValue(isolate, color_depth_value, exception_state);
    if (exception_state.HadException())
      return;
    impl->setColorDepth(color_depth_cpp_value);
  }

  v8::Local<v8::Value> height_value;
  if (!v8Object->Get(context, keys[1].Get(isolate)).ToLocal(&height_value)) {
    exception_state.RethrowV8Exception(block.Exception());
    return;
  }
  if (height_value.IsEmpty() || height_value->IsUndefined()) {
    exception_state.ThrowTypeError("required member height is undefined.");
    return;
  } else {
    int32_t height_cpp_value = NativeValueTraits<IDLLong>::NativeValue(isolate, height_value, exception_state);
    if (exception_state.HadException())
      return;
    impl->setHeight(height_cpp_value);
  }

  v8::Local<v8::Value> is_internal_value;
  if (!v8Object->Get(context, keys[2].Get(isolate)).ToLocal(&is_internal_value)) {
    exception_state.RethrowV8Exception(block.Exception());
    return;
  }
  if (is_internal_value.IsEmpty() || is_internal_value->IsUndefined()) {
    exception_state.ThrowTypeError("required member isInternal is undefined.");
    return;
  } else {
    bool is_internal_cpp_value = NativeValueTraits<IDLBoolean>::NativeValue(isolate, is_internal_value, exception_state);
    if (exception_state.HadException())
      return;
    impl->setIsInternal(is_internal_cpp_value);
  }

  v8::Local<v8::Value> is_primary_value;
  if (!v8Object->Get(context, keys[3].Get(isolate)).ToLocal(&is_primary_value)) {
    exception_state.RethrowV8Exception(block.Exception());
    return;
  }
  if (is_primary_value.IsEmpty() || is_primary_value->IsUndefined()) {
    exception_state.ThrowTypeError("required member isPrimary is undefined.");
    return;
  } else {
    bool is_primary_cpp_value = NativeValueTraits<IDLBoolean>::NativeValue(isolate, is_primary_value, exception_state);
    if (exception_state.HadException())
      return;
    impl->setIsPrimary(is_primary_cpp_value);
  }

  v8::Local<v8::Value> left_value;
  if (!v8Object->Get(context, keys[4].Get(isolate)).ToLocal(&left_value)) {
    exception_state.RethrowV8Exception(block.Exception());
    return;
  }
  if (left_value.IsEmpty() || left_value->IsUndefined()) {
    exception_state.ThrowTypeError("required member left is undefined.");
    return;
  } else {
    int32_t left_cpp_value = NativeValueTraits<IDLLong>::NativeValue(isolate, left_value, exception_state);
    if (exception_state.HadException())
      return;
    impl->setLeft(left_cpp_value);
  }

  v8::Local<v8::Value> name_value;
  if (!v8Object->Get(context, keys[5].Get(isolate)).ToLocal(&name_value)) {
    exception_state.RethrowV8Exception(block.Exception());
    return;
  }
  if (name_value.IsEmpty() || name_value->IsUndefined()) {
    exception_state.ThrowTypeError("required member name is undefined.");
    return;
  } else {
    V8StringResource<> name_cpp_value = name_value;
    if (!name_cpp_value.Prepare(exception_state))
      return;
    impl->setName(name_cpp_value);
  }

  v8::Local<v8::Value> scale_factor_value;
  if (!v8Object->Get(context, keys[6].Get(isolate)).ToLocal(&scale_factor_value)) {
    exception_state.RethrowV8Exception(block.Exception());
    return;
  }
  if (scale_factor_value.IsEmpty() || scale_factor_value->IsUndefined()) {
    exception_state.ThrowTypeError("required member scaleFactor is undefined.");
    return;
  } else {
    float scale_factor_cpp_value = NativeValueTraits<IDLFloat>::NativeValue(isolate, scale_factor_value, exception_state);
    if (exception_state.HadException())
      return;
    impl->setScaleFactor(scale_factor_cpp_value);
  }

  v8::Local<v8::Value> top_value;
  if (!v8Object->Get(context, keys[7].Get(isolate)).ToLocal(&top_value)) {
    exception_state.RethrowV8Exception(block.Exception());
    return;
  }
  if (top_value.IsEmpty() || top_value->IsUndefined()) {
    exception_state.ThrowTypeError("required member top is undefined.");
    return;
  } else {
    int32_t top_cpp_value = NativeValueTraits<IDLLong>::NativeValue(isolate, top_value, exception_state);
    if (exception_state.HadException())
      return;
    impl->setTop(top_cpp_value);
  }

  v8::Local<v8::Value> width_value;
  if (!v8Object->Get(context, keys[8].Get(isolate)).ToLocal(&width_value)) {
    exception_state.RethrowV8Exception(block.Exception());
    return;
  }
  if (width_value.IsEmpty() || width_value->IsUndefined()) {
    exception_state.ThrowTypeError("required member width is undefined.");
    return;
  } else {
    int32_t width_cpp_value = NativeValueTraits<IDLLong>::NativeValue(isolate, width_value, exception_state);
    if (exception_state.HadException())
      return;
    impl->setWidth(width_cpp_value);
  }
}

v8::Local<v8::Value> Display::ToV8Impl(v8::Local<v8::Object> creationContext, v8::Isolate* isolate) const {
  v8::Local<v8::Object> v8Object = v8::Object::New(isolate);
  if (!toV8Display(this, v8Object, creationContext, isolate))
    return v8::Undefined(isolate);
  return v8Object;
}

bool toV8Display(const Display* impl, v8::Local<v8::Object> dictionary, v8::Local<v8::Object> creationContext, v8::Isolate* isolate) {
  const v8::Eternal<v8::Name>* keys = eternalV8DisplayKeys(isolate);
  v8::Local<v8::Context> context = isolate->GetCurrentContext();

  auto create_property = [dictionary, context, keys, isolate](
                             size_t key_index, v8::Local<v8::Value> value) {
    bool added_property;
    v8::Local<v8::Name> key = keys[key_index].Get(isolate);
    if (!dictionary->CreateDataProperty(context, key, value)
             .To(&added_property)) {
      return false;
    }
    return added_property;
  };

  v8::Local<v8::Value> color_depth_value;
  bool color_depth_has_value_or_default = false;
  if (impl->hasColorDepth()) {
    color_depth_value = v8::Integer::New(isolate, impl->colorDepth());
    color_depth_has_value_or_default = true;
  } else {
    NOTREACHED();
  }
  if (color_depth_has_value_or_default &&
      !create_property(0, color_depth_value)) {
    return false;
  }

  v8::Local<v8::Value> height_value;
  bool height_has_value_or_default = false;
  if (impl->hasHeight()) {
    height_value = v8::Integer::New(isolate, impl->height());
    height_has_value_or_default = true;
  } else {
    NOTREACHED();
  }
  if (height_has_value_or_default &&
      !create_property(1, height_value)) {
    return false;
  }

  v8::Local<v8::Value> is_internal_value;
  bool is_internal_has_value_or_default = false;
  if (impl->hasIsInternal()) {
    is_internal_value = v8::Boolean::New(isolate, impl->isInternal());
    is_internal_has_value_or_default = true;
  } else {
    NOTREACHED();
  }
  if (is_internal_has_value_or_default &&
      !create_property(2, is_internal_value)) {
    return false;
  }

  v8::Local<v8::Value> is_primary_value;
  bool is_primary_has_value_or_default = false;
  if (impl->hasIsPrimary()) {
    is_primary_value = v8::Boolean::New(isolate, impl->isPrimary());
    is_primary_has_value_or_default = true;
  } else {
    NOTREACHED();
  }
  if (is_primary_has_value_or_default &&
      !create_property(3, is_primary_value)) {
    return false;
  }

  v8::Local<v8::Value> left_value;
  bool left_has_value_or_default = false;
  if (impl->hasLeft()) {
    left_value = v8::Integer::New(isolate, impl->left());
    left_has_value_or_default = true;
  } else {
    NOTREACHED();
  }
  if (left_has_value_or_default &&
      !create_property(4, left_value)) {
    return false;
  }

  v8::Local<v8::Value> name_value;
  bool name_has_value_or_default = false;
  if (impl->hasName()) {
    name_value = V8String(isolate, impl->name());
    name_has_value_or_default = true;
  } else {
    NOTREACHED();
  }
  if (name_has_value_or_default &&
      !create_property(5, name_value)) {
    return false;
  }

  v8::Local<v8::Value> scale_factor_value;
  bool scale_factor_has_value_or_default = false;
  if (impl->hasScaleFactor()) {
    scale_factor_value = v8::Number::New(isolate, impl->scaleFactor());
    scale_factor_has_value_or_default = true;
  } else {
    NOTREACHED();
  }
  if (scale_factor_has_value_or_default &&
      !create_property(6, scale_factor_value)) {
    return false;
  }

  v8::Local<v8::Value> top_value;
  bool top_has_value_or_default = false;
  if (impl->hasTop()) {
    top_value = v8::Integer::New(isolate, impl->top());
    top_has_value_or_default = true;
  } else {
    NOTREACHED();
  }
  if (top_has_value_or_default &&
      !create_property(7, top_value)) {
    return false;
  }

  v8::Local<v8::Value> width_value;
  bool width_has_value_or_default = false;
  if (impl->hasWidth()) {
    width_value = v8::Integer::New(isolate, impl->width());
    width_has_value_or_default = true;
  } else {
    NOTREACHED();
  }
  if (width_has_value_or_default &&
      !create_property(8, width_value)) {
    return false;
  }

  return true;
}

Display* NativeValueTraits<Display>::NativeValue(v8::Isolate* isolate, v8::Local<v8::Value> value, ExceptionState& exception_state) {
  Display* impl = Display::Create();
  V8Display::ToImpl(isolate, value, impl, exception_state);
  return impl;
}

}  // namespace blink
