// Copyright (c) 2014 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// Generated from template:
//   templates/feature_policy_helper.cc.tmpl
// and input files:
//   ../../third_party/blink/renderer/core/feature_policy/feature_policy_features.json5
//   ../../third_party/blink/renderer/platform/runtime_enabled_features.json5


#include "third_party/blink/renderer/core/feature_policy/feature_policy_helper.h"

#include "third_party/blink/renderer/core/execution_context/execution_context.h"
#include "third_party/blink/renderer/core/origin_trials/origin_trials.h"
#include "third_party/blink/renderer/platform/runtime_enabled_features.h"

namespace blink {

namespace {

const char kAccelerometerPolicyName[] = "accelerometer";
const char kAmbientLightSensorPolicyName[] = "ambient-light-sensor";
const char kAutoplayPolicyName[] = "autoplay";
const char kCameraPolicyName[] = "camera";
const char kClientHintDPRPolicyName[] = "ch-dpr";
const char kClientHintDeviceMemoryPolicyName[] = "ch-device-memory";
const char kClientHintDownlinkPolicyName[] = "ch-downlink";
const char kClientHintECTPolicyName[] = "ch-ect";
const char kClientHintLangPolicyName[] = "ch-lang";
const char kClientHintRTTPolicyName[] = "ch-rtt";
const char kClientHintUAPolicyName[] = "ch-ua";
const char kClientHintUAArchPolicyName[] = "ch-ua-arch";
const char kClientHintUAPlatformPolicyName[] = "ch-ua-platform";
const char kClientHintUAModelPolicyName[] = "ch-ua-model";
const char kClientHintViewportWidthPolicyName[] = "ch-viewport-width";
const char kClientHintWidthPolicyName[] = "ch-width";
const char kDocumentAccessPolicyName[] = "document-access";
const char kDocumentDomainPolicyName[] = "document-domain";
const char kDocumentWritePolicyName[] = "document-write";
const char kDownloadsWithoutUserActivationPolicyName[] = "downloads-without-user-activation";
const char kEncryptedMediaPolicyName[] = "encrypted-media";
const char kExecutionWhileOutOfViewportPolicyName[] = "execution-while-out-of-viewport";
const char kExecutionWhileNotRenderedPolicyName[] = "execution-while-not-rendered";
const char kFocusWithoutUserActivationPolicyName[] = "focus-without-user-activation";
const char kFontDisplayPolicyName[] = "font-display-late-swap";
const char kFormSubmissionPolicyName[] = "forms";
const char kFullscreenPolicyName[] = "fullscreen";
const char kFrobulatePolicyName[] = "frobulate";
const char kGeolocationPolicyName[] = "geolocation";
const char kGyroscopePolicyName[] = "gyroscope";
const char kHidPolicyName[] = "hid";
const char kIdleDetectionPolicyName[] = "idle-detection";
const char kLayoutAnimationsPolicyName[] = "layout-animations";
const char kLazyLoadPolicyName[] = "lazyload";
const char kLoadingFrameDefaultEagerPolicyName[] = "loading-frame-default-eager";
const char kMagnetometerPolicyName[] = "magnetometer";
const char kMicrophonePolicyName[] = "microphone";
const char kMidiFeaturePolicyName[] = "midi";
const char kModalsPolicyName[] = "modals";
const char kOrientationLockPolicyName[] = "orientation-lock";
const char kOversizedImagesPolicyName[] = "oversized-images";
const char kPaymentPolicyName[] = "payment";
const char kPictureInPicturePolicyName[] = "picture-in-picture";
const char kPointerLockPolicyName[] = "pointer-lock";
const char kPopupsPolicyName[] = "popups";
const char kPresentationPolicyName[] = "presentation";
const char kScriptPolicyName[] = "scripts";
const char kSerialPolicyName[] = "serial";
const char kSyncScriptPolicyName[] = "sync-script";
const char kSyncXHRPolicyName[] = "sync-xhr";
const char kTopNavigationPolicyName[] = "top-navigation";
const char kUnoptimizedLosslessImagesPolicyName[] = "unoptimized-lossless-images";
const char kUnoptimizedLosslessImagesStrictPolicyName[] = "unoptimized-lossless-images-strict";
const char kUnoptimizedLossyImagesPolicyName[] = "unoptimized-lossy-images";
const char kUnsizedMediaPolicyName[] = "unsized-media";
const char kUsbPolicyName[] = "usb";
const char kVerticalScrollPolicyName[] = "vertical-scroll";
const char kWakeLockPolicyName[] = "wake-lock";
const char kWebXrPolicyName[] = "xr";

}  // namespace

// Features which depend on a flag also have the same flag controlling whether
// they are in this map. Features which are shipping as part of an origin trial
// add their feature names to this map unconditionally, as the trial token could
// be added after the HTTP header needs to be parsed. This also means that
// top-level documents which simply want to embed another page which uses an
// origin trial feature, without using the feature themselves, can use feature
// policy to allow use of the feature in subframes (The framed document will
// still require a valid origin trial token to use the feature in this scenario).
const FeatureNameMap& GetDefaultFeatureNameMap() {
  DEFINE_STATIC_LOCAL(FeatureNameMap, default_feature_name_map, ());
  if (default_feature_name_map.IsEmpty()) {
    default_feature_name_map.Set(kAccelerometerPolicyName,
                                 mojom::FeaturePolicyFeature::kAccelerometer);
    default_feature_name_map.Set(kAmbientLightSensorPolicyName,
                                 mojom::FeaturePolicyFeature::kAmbientLightSensor);
    default_feature_name_map.Set(kAutoplayPolicyName,
                                 mojom::FeaturePolicyFeature::kAutoplay);
    default_feature_name_map.Set(kCameraPolicyName,
                                 mojom::FeaturePolicyFeature::kCamera);
    default_feature_name_map.Set(kDocumentDomainPolicyName,
                                 mojom::FeaturePolicyFeature::kDocumentDomain);
    default_feature_name_map.Set(kEncryptedMediaPolicyName,
                                 mojom::FeaturePolicyFeature::kEncryptedMedia);
    default_feature_name_map.Set(kFullscreenPolicyName,
                                 mojom::FeaturePolicyFeature::kFullscreen);
    default_feature_name_map.Set(kFrobulatePolicyName,
                                 mojom::FeaturePolicyFeature::kFrobulate);
    default_feature_name_map.Set(kGeolocationPolicyName,
                                 mojom::FeaturePolicyFeature::kGeolocation);
    default_feature_name_map.Set(kGyroscopePolicyName,
                                 mojom::FeaturePolicyFeature::kGyroscope);
    default_feature_name_map.Set(kMagnetometerPolicyName,
                                 mojom::FeaturePolicyFeature::kMagnetometer);
    default_feature_name_map.Set(kMicrophonePolicyName,
                                 mojom::FeaturePolicyFeature::kMicrophone);
    default_feature_name_map.Set(kMidiFeaturePolicyName,
                                 mojom::FeaturePolicyFeature::kMidiFeature);
    default_feature_name_map.Set(kOversizedImagesPolicyName,
                                 mojom::FeaturePolicyFeature::kOversizedImages);
    default_feature_name_map.Set(kSyncXHRPolicyName,
                                 mojom::FeaturePolicyFeature::kSyncXHR);
    default_feature_name_map.Set(kUnoptimizedLosslessImagesPolicyName,
                                 mojom::FeaturePolicyFeature::kUnoptimizedLosslessImages);
    default_feature_name_map.Set(kUnoptimizedLosslessImagesStrictPolicyName,
                                 mojom::FeaturePolicyFeature::kUnoptimizedLosslessImagesStrict);
    default_feature_name_map.Set(kUnoptimizedLossyImagesPolicyName,
                                 mojom::FeaturePolicyFeature::kUnoptimizedLossyImages);
    default_feature_name_map.Set(kUnsizedMediaPolicyName,
                                 mojom::FeaturePolicyFeature::kUnsizedMedia);
    default_feature_name_map.Set(kWakeLockPolicyName,
                                 mojom::FeaturePolicyFeature::kWakeLock);
    default_feature_name_map.Set(kWebXrPolicyName,
                                 mojom::FeaturePolicyFeature::kWebXr);
    // TODO(crbug.com/960132): WebVR manually added here for compatibility.
    // Remove this when WebVR is removed.
    ASSERT_ORIGIN_TRIAL(WebVR);
    default_feature_name_map.Set("vr", mojom::FeaturePolicyFeature::kWebVr);
    if (RuntimeEnabledFeatures::IdleDetectionEnabled()) {
      default_feature_name_map.Set(kIdleDetectionPolicyName,
                                   mojom::FeaturePolicyFeature::kIdleDetection);
    }
    if (RuntimeEnabledFeatures::PictureInPictureAPIEnabled()) {
      default_feature_name_map.Set(kPictureInPicturePolicyName,
                                   mojom::FeaturePolicyFeature::kPictureInPicture);
    }
    if (RuntimeEnabledFeatures::WebHIDEnabled()) {
      default_feature_name_map.Set(kHidPolicyName,
                                   mojom::FeaturePolicyFeature::kHid);
    }
    if (RuntimeEnabledFeatures::PaymentRequestEnabled()) {
      default_feature_name_map.Set(kPaymentPolicyName,
                                   mojom::FeaturePolicyFeature::kPayment);
    }
    if (RuntimeEnabledFeatures::FreezeFramesOnVisibilityEnabled()) {
      default_feature_name_map.Set(kExecutionWhileOutOfViewportPolicyName,
                                   mojom::FeaturePolicyFeature::kExecutionWhileOutOfViewport);
      default_feature_name_map.Set(kExecutionWhileNotRenderedPolicyName,
                                   mojom::FeaturePolicyFeature::kExecutionWhileNotRendered);
    }
    if (RuntimeEnabledFeatures::FeaturePolicyForSandboxEnabled()) {
      default_feature_name_map.Set(kDownloadsWithoutUserActivationPolicyName,
                                   mojom::FeaturePolicyFeature::kDownloadsWithoutUserActivation);
      default_feature_name_map.Set(kFormSubmissionPolicyName,
                                   mojom::FeaturePolicyFeature::kFormSubmission);
      default_feature_name_map.Set(kModalsPolicyName,
                                   mojom::FeaturePolicyFeature::kModals);
      default_feature_name_map.Set(kOrientationLockPolicyName,
                                   mojom::FeaturePolicyFeature::kOrientationLock);
      default_feature_name_map.Set(kPointerLockPolicyName,
                                   mojom::FeaturePolicyFeature::kPointerLock);
      default_feature_name_map.Set(kPopupsPolicyName,
                                   mojom::FeaturePolicyFeature::kPopups);
      default_feature_name_map.Set(kPresentationPolicyName,
                                   mojom::FeaturePolicyFeature::kPresentation);
      default_feature_name_map.Set(kScriptPolicyName,
                                   mojom::FeaturePolicyFeature::kScript);
      default_feature_name_map.Set(kTopNavigationPolicyName,
                                   mojom::FeaturePolicyFeature::kTopNavigation);
    }
    if (RuntimeEnabledFeatures::ExperimentalProductivityFeaturesEnabled()) {
      default_feature_name_map.Set(kDocumentAccessPolicyName,
                                   mojom::FeaturePolicyFeature::kDocumentAccess);
      default_feature_name_map.Set(kDocumentWritePolicyName,
                                   mojom::FeaturePolicyFeature::kDocumentWrite);
      default_feature_name_map.Set(kFontDisplayPolicyName,
                                   mojom::FeaturePolicyFeature::kFontDisplay);
      default_feature_name_map.Set(kLayoutAnimationsPolicyName,
                                   mojom::FeaturePolicyFeature::kLayoutAnimations);
      default_feature_name_map.Set(kLazyLoadPolicyName,
                                   mojom::FeaturePolicyFeature::kLazyLoad);
      default_feature_name_map.Set(kLoadingFrameDefaultEagerPolicyName,
                                   mojom::FeaturePolicyFeature::kLoadingFrameDefaultEager);
      default_feature_name_map.Set(kSyncScriptPolicyName,
                                   mojom::FeaturePolicyFeature::kSyncScript);
      default_feature_name_map.Set(kVerticalScrollPolicyName,
                                   mojom::FeaturePolicyFeature::kVerticalScroll);
    }
    if (RuntimeEnabledFeatures::ClientHintsFeaturePolicyEnabled()) {
      default_feature_name_map.Set(kClientHintDPRPolicyName,
                                   mojom::FeaturePolicyFeature::kClientHintDPR);
      default_feature_name_map.Set(kClientHintDeviceMemoryPolicyName,
                                   mojom::FeaturePolicyFeature::kClientHintDeviceMemory);
      default_feature_name_map.Set(kClientHintDownlinkPolicyName,
                                   mojom::FeaturePolicyFeature::kClientHintDownlink);
      default_feature_name_map.Set(kClientHintECTPolicyName,
                                   mojom::FeaturePolicyFeature::kClientHintECT);
      default_feature_name_map.Set(kClientHintLangPolicyName,
                                   mojom::FeaturePolicyFeature::kClientHintLang);
      default_feature_name_map.Set(kClientHintRTTPolicyName,
                                   mojom::FeaturePolicyFeature::kClientHintRTT);
      default_feature_name_map.Set(kClientHintUAPolicyName,
                                   mojom::FeaturePolicyFeature::kClientHintUA);
      default_feature_name_map.Set(kClientHintUAArchPolicyName,
                                   mojom::FeaturePolicyFeature::kClientHintUAArch);
      default_feature_name_map.Set(kClientHintUAPlatformPolicyName,
                                   mojom::FeaturePolicyFeature::kClientHintUAPlatform);
      default_feature_name_map.Set(kClientHintUAModelPolicyName,
                                   mojom::FeaturePolicyFeature::kClientHintUAModel);
      default_feature_name_map.Set(kClientHintViewportWidthPolicyName,
                                   mojom::FeaturePolicyFeature::kClientHintViewportWidth);
      default_feature_name_map.Set(kClientHintWidthPolicyName,
                                   mojom::FeaturePolicyFeature::kClientHintWidth);
    }
    if (RuntimeEnabledFeatures::SerialEnabled()) {
      default_feature_name_map.Set(kSerialPolicyName,
                                   mojom::FeaturePolicyFeature::kSerial);
    }
    if (RuntimeEnabledFeatures::WebUSBEnabled()) {
      default_feature_name_map.Set(kUsbPolicyName,
                                   mojom::FeaturePolicyFeature::kUsb);
    }
    if (RuntimeEnabledFeatures::BlockingFocusWithoutUserActivationEnabled()) {
      default_feature_name_map.Set(kFocusWithoutUserActivationPolicyName,
                                   mojom::FeaturePolicyFeature::kFocusWithoutUserActivation);
    }
  }
  return default_feature_name_map;
}

bool DisabledByOriginTrial(const String& feature_name,
                           FeatureContext* feature_context) {
  if (feature_name == kUnoptimizedLossyImagesPolicyName) {
    return !RuntimeEnabledFeatures::UnoptimizedImagePoliciesEnabled(feature_context);
  }
  if (feature_name == kUnoptimizedLosslessImagesStrictPolicyName) {
    return !RuntimeEnabledFeatures::UnoptimizedImagePoliciesEnabled(feature_context);
  }
  if (feature_name == kOversizedImagesPolicyName) {
    return !RuntimeEnabledFeatures::UnoptimizedImagePoliciesEnabled(feature_context);
  }
  if (feature_name == kUnoptimizedLosslessImagesPolicyName) {
    return !RuntimeEnabledFeatures::UnoptimizedImagePoliciesEnabled(feature_context);
  }
  if (feature_name == kWebXrPolicyName) {
    return !RuntimeEnabledFeatures::WebXREnabled(feature_context);
  }
  if (feature_name == kFrobulatePolicyName) {
    return !RuntimeEnabledFeatures::OriginTrialsSampleAPIEnabled(feature_context);
  }
  if (feature_name == kUnsizedMediaPolicyName) {
    return !RuntimeEnabledFeatures::UnsizedMediaPolicyEnabled(feature_context);
  }
  if (feature_name == kWakeLockPolicyName) {
    return !RuntimeEnabledFeatures::WakeLockEnabled(feature_context);
  }
  return false;
}

}  // namespace blink
