// Copyright 2014 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// This file has been auto-generated from the Jinja2 template
// third_party/blink/renderer/bindings/templates/dictionary_impl.h.tmpl
// by the script code_generator_v8.py.
// DO NOT MODIFY!

// clang-format off
#ifndef THIRD_PARTY_BLINK_RENDERER_MODULES_SCREEN_ENUMERATION_DISPLAY_H_
#define THIRD_PARTY_BLINK_RENDERER_MODULES_SCREEN_ENUMERATION_DISPLAY_H_

#include "third_party/blink/renderer/bindings/core/v8/idl_dictionary_base.h"
#include "third_party/blink/renderer/modules/modules_export.h"
#include "third_party/blink/renderer/platform/heap/handle.h"
#include "third_party/blink/renderer/platform/wtf/text/wtf_string.h"

namespace blink {

class MODULES_EXPORT Display : public IDLDictionaryBase {
 public:
  static Display* Create() { return MakeGarbageCollected<Display>(); }

  Display();
  virtual ~Display();

  bool hasColorDepth() const { return has_color_depth_; }
  int32_t colorDepth() const {
    DCHECK(has_color_depth_);
    return color_depth_;
  }
  inline void setColorDepth(int32_t);

  bool hasHeight() const { return has_height_; }
  int32_t height() const {
    DCHECK(has_height_);
    return height_;
  }
  inline void setHeight(int32_t);

  bool hasIsInternal() const { return has_is_internal_; }
  bool isInternal() const {
    DCHECK(has_is_internal_);
    return is_internal_;
  }
  inline void setIsInternal(bool);

  bool hasIsPrimary() const { return has_is_primary_; }
  bool isPrimary() const {
    DCHECK(has_is_primary_);
    return is_primary_;
  }
  inline void setIsPrimary(bool);

  bool hasLeft() const { return has_left_; }
  int32_t left() const {
    DCHECK(has_left_);
    return left_;
  }
  inline void setLeft(int32_t);

  bool hasName() const { return !name_.IsNull(); }
  const String& name() const {
    return name_;
  }
  inline void setName(const String&);

  bool hasScaleFactor() const { return has_scale_factor_; }
  float scaleFactor() const {
    DCHECK(has_scale_factor_);
    return scale_factor_;
  }
  inline void setScaleFactor(float);

  bool hasTop() const { return has_top_; }
  int32_t top() const {
    DCHECK(has_top_);
    return top_;
  }
  inline void setTop(int32_t);

  bool hasWidth() const { return has_width_; }
  int32_t width() const {
    DCHECK(has_width_);
    return width_;
  }
  inline void setWidth(int32_t);

  v8::Local<v8::Value> ToV8Impl(v8::Local<v8::Object>, v8::Isolate*) const override;
  void Trace(blink::Visitor*) override;

 private:
  bool has_color_depth_ = false;
  bool has_height_ = false;
  bool has_is_internal_ = false;
  bool has_is_primary_ = false;
  bool has_left_ = false;
  bool has_scale_factor_ = false;
  bool has_top_ = false;
  bool has_width_ = false;

  int32_t color_depth_;
  int32_t height_;
  bool is_internal_;
  bool is_primary_;
  int32_t left_;
  String name_;
  float scale_factor_;
  int32_t top_;
  int32_t width_;

  friend class V8Display;
};

void Display::setColorDepth(int32_t value) {
  color_depth_ = value;
  has_color_depth_ = true;
}

void Display::setHeight(int32_t value) {
  height_ = value;
  has_height_ = true;
}

void Display::setIsInternal(bool value) {
  is_internal_ = value;
  has_is_internal_ = true;
}

void Display::setIsPrimary(bool value) {
  is_primary_ = value;
  has_is_primary_ = true;
}

void Display::setLeft(int32_t value) {
  left_ = value;
  has_left_ = true;
}

void Display::setName(const String& value) {
  name_ = value;
}

void Display::setScaleFactor(float value) {
  scale_factor_ = value;
  has_scale_factor_ = true;
}

void Display::setTop(int32_t value) {
  top_ = value;
  has_top_ = true;
}

void Display::setWidth(int32_t value) {
  width_ = value;
  has_width_ = true;
}

}  // namespace blink

#endif  // THIRD_PARTY_BLINK_RENDERER_MODULES_SCREEN_ENUMERATION_DISPLAY_H_
